/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.  *
 **************************************************************************/
package org.exoplatform.faces.core.renderer.html;

import java.util.Map;
import java.io.IOException;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import org.exoplatform.faces.FacesUtil;
import org.exoplatform.faces.core.component.UIStringInput;


public class StringInputRenderer extends HtmlBasicRenderer {

	public void decode(FacesContext context, UIComponent component) {
		UIStringInput uiInput = (UIStringInput) component;
    if(uiInput.isReadonly()) return ;
		Map paramMap = context.getExternalContext().getRequestParameterMap();
		String value = (String) paramMap.get(uiInput.getName());
		if (value == null) return  ;
		// Update managed bean (model object)		
		if (!FacesUtil.updateBoundValueBinding(context, component, "text", value)) {		
			uiInput.setText(value);
		}
	}

	public void encodeBegin(FacesContext context, UIComponent component) throws IOException {
	  ResponseWriter w = context.getResponseWriter() ;
	  UIStringInput uiInput = (UIStringInput) component;
	  String value = uiInput.getValue();
	  String type = "";
	  switch(uiInput.getType()) {
	    case UIStringInput.TEXT : type = "text"; break;
	    case UIStringInput.PASSWORD : type = "password";
	  }
	  if (value == null) value = "";
	  // Try to resolve elvalue text
	  if (FacesUtil.isValueReference(value)) {
	    value = (String) FacesUtil.resolveBoundValueBinding(context, uiInput, "text");				
	  }
	  w.write("<input name='"); w.write(uiInput.getName()); w.write("'") ;
    if(value == null) value = "" ;
	  w.write(" value='"); w.write(value); w.write("'");
	  w.write(" type='"); w.write(type); w.write("'");
	  if (uiInput.getClazz() != null) {
	    w.write(" class='"); w.write(uiInput.getClazz()); w.write("'");
	  }
	  if (uiInput.getTitle() != null) {
	    w.write(" title='"); w.write(uiInput.getTitle()); w.write("'");
	  }
	  if(!uiInput.isEditable() || uiInput.isReadonly()) {
	    w.write(" readonly='readonly' ");
    }
	  w.write("/>");
	  if(uiInput.hasError()) {
	    w.write("<span style='color: red'>*</span>") ;
	  }
	}
}

