/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.communication.forum.hibernate;

import java.io.InputStream;
import java.util.Enumeration;
import java.util.jar.JarEntry;
import java.util.jar.JarFile;
import java.util.List ;
import net.sf.hibernate.Session;
import org.exoplatform.commons.utils.IOUtil;
import com.thoughtworks.xstream.XStream;

/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Nov 21, 2004
 * @version $Id$
 */
public class ForumImporter {
  private Session session_ ;
  private JarFile jar_ ;
  private XStream xstream_ ;
  
  public ForumImporter(Session session, JarFile jar, XStream xstream) {
    session_ = session ;
    jar_ = jar ;
    xstream_ = xstream ;
  }
  
  public void importData() throws Exception {
    Enumeration e = jar_.entries() ;
    while(e.hasMoreElements()) {
      JarEntry entry = (JarEntry) e.nextElement() ;
      InputStream is = jar_.getInputStream(entry) ;
      String xml = IOUtil.getStreamContentAsString(is) ;
      String entryName = entry.getName() ;
      if(entryName.endsWith(".category")) {
        CategoryImpl category = (CategoryImpl)xstream_.fromXML(xml) ;
        session_.saveOrUpdateCopy(category) ;
      } else if(entryName.endsWith(".forum")) {
        ForumImpl forum  = (ForumImpl) xstream_.fromXML(xml) ;
        session_.saveOrUpdateCopy(forum) ;
      } else if(entryName.endsWith(".topic")) {
        TopicBackup backup = (TopicBackup) xstream_.fromXML(xml) ;
        TopicImpl topic = backup.getTopic() ;
        List posts = backup.getPosts() ;
        for(int i = 0 ; i < posts.size(); i++) {
          PostImpl post = (PostImpl) posts.get(i) ;
          session_.saveOrUpdateCopy(post) ;
        }
        session_.saveOrUpdateCopy(topic) ;
      }
      session_.flush() ;
    }
  }
}
