/***************************************************************************
 * Copyright 2001-2004 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.organization.ldap;

import org.exoplatform.services.organization.impl.UserProfileImpl;

import com.thoughtworks.xstream.XStream;
import com.thoughtworks.xstream.io.xml.XppDriver;


/**
 * Created by the eXo platform team
 * User: Daniel Summer
 * Date: 28 august 2004
 *
 */
public class UserProfileLDAPData {
	static transient private XStream xstream_ ; 
	
  private String userName ;
  private String profile ;

  public UserProfileLDAPData() {
  }
  
  public UserProfileLDAPData(String userName) {
    StringBuffer b = new StringBuffer() ;
    b.append("<user-profile>\n").
      append("  <userName>").append(userName).append("</userName>\n");
    b.append("</user-profile>\n");
    this.userName = userName ;
    this.profile = b.toString() ;
  }

  /**
   * @hibernate.id  generator-class="assigned"
   **/
  public String  getUserName() { return userName ; }
  public void  setUserName(String s) { this.userName = s ; } 

  /**
   * @hibernate.property
   **/
  public String getProfile() { return profile ; }
  public void setProfile(String s) { profile = s; }

  public org.exoplatform.services.organization.UserProfile getUserProfile() {
    XStream xstream = getXStream() ;
    UserProfileImpl up = (UserProfileImpl)xstream.fromXML(profile) ;
    return up ;
  }

  public void setUserProfile(org.exoplatform.services.organization.UserProfile up) { 
  	UserProfileImpl impl = (UserProfileImpl) up ;
  	userName = up.getUserName() ;
  	XStream xstream = getXStream() ;
  	profile = xstream.toXML(impl) ; 
  }
  
  static private XStream  getXStream() {
  	if (xstream_ == null) {
  		xstream_ = new XStream(new XppDriver());
      xstream_.alias("user-profile", UserProfileImpl.class);
  	}
  	return xstream_ ;
  }
}